/* Generated by wayland-scanner 1.21.0 */

#ifndef EXAMPLE_SHELL_CLIENT_PROTOCOL_H
#define EXAMPLE_SHELL_CLIENT_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-client-core.h"

#ifdef  __cplusplus
extern "C" {
#endif

/**
 * @page page_example_shell The example_shell protocol
 * @section page_ifaces_example_shell Interfaces
 * - @subpage page_iface_qt_example_shell_surface - 
 * - @subpage page_iface_qt_example_shell - 
 * @section page_copyright_example_shell Copyright
 * <pre>
 *
 * Copyright (C) 2021 The Qt Company Ltd.
 * SPDX-License-Identifier: LicenseRef-Qt-Commercial OR BSD-3-Clause
 * </pre>
 */
struct qt_example_shell;
struct qt_example_shell_surface;
struct wl_surface;

#ifndef QT_EXAMPLE_SHELL_SURFACE_INTERFACE
#define QT_EXAMPLE_SHELL_SURFACE_INTERFACE
/**
 * @page page_iface_qt_example_shell_surface qt_example_shell_surface
 * @section page_iface_qt_example_shell_surface_api API
 * See @ref iface_qt_example_shell_surface.
 */
/**
 * @defgroup iface_qt_example_shell_surface The qt_example_shell_surface interface
 */
extern const struct wl_interface qt_example_shell_surface_interface;
#endif
#ifndef QT_EXAMPLE_SHELL_INTERFACE
#define QT_EXAMPLE_SHELL_INTERFACE
/**
 * @page page_iface_qt_example_shell qt_example_shell
 * @section page_iface_qt_example_shell_api API
 * See @ref iface_qt_example_shell.
 */
/**
 * @defgroup iface_qt_example_shell The qt_example_shell interface
 */
extern const struct wl_interface qt_example_shell_interface;
#endif

/**
 * @ingroup iface_qt_example_shell_surface
 * @struct qt_example_shell_surface_listener
 */
struct qt_example_shell_surface_listener {
	/**
	 */
	void (*minimize)(void *data,
			 struct qt_example_shell_surface *qt_example_shell_surface,
			 uint32_t minimized);
};

/**
 * @ingroup iface_qt_example_shell_surface
 */
static inline int
qt_example_shell_surface_add_listener(struct qt_example_shell_surface *qt_example_shell_surface,
				      const struct qt_example_shell_surface_listener *listener, void *data)
{
	return wl_proxy_add_listener((struct wl_proxy *) qt_example_shell_surface,
				     (void (**)(void)) listener, data);
}

#define QT_EXAMPLE_SHELL_SURFACE_DESTROY 0
#define QT_EXAMPLE_SHELL_SURFACE_SET_WINDOW_TITLE 1
#define QT_EXAMPLE_SHELL_SURFACE_SET_MINIMIZED 2

/**
 * @ingroup iface_qt_example_shell_surface
 */
#define QT_EXAMPLE_SHELL_SURFACE_MINIMIZE_SINCE_VERSION 1

/**
 * @ingroup iface_qt_example_shell_surface
 */
#define QT_EXAMPLE_SHELL_SURFACE_DESTROY_SINCE_VERSION 1
/**
 * @ingroup iface_qt_example_shell_surface
 */
#define QT_EXAMPLE_SHELL_SURFACE_SET_WINDOW_TITLE_SINCE_VERSION 1
/**
 * @ingroup iface_qt_example_shell_surface
 */
#define QT_EXAMPLE_SHELL_SURFACE_SET_MINIMIZED_SINCE_VERSION 1

/** @ingroup iface_qt_example_shell_surface */
static inline void
qt_example_shell_surface_set_user_data(struct qt_example_shell_surface *qt_example_shell_surface, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) qt_example_shell_surface, user_data);
}

/** @ingroup iface_qt_example_shell_surface */
static inline void *
qt_example_shell_surface_get_user_data(struct qt_example_shell_surface *qt_example_shell_surface)
{
	return wl_proxy_get_user_data((struct wl_proxy *) qt_example_shell_surface);
}

static inline uint32_t
qt_example_shell_surface_get_version(struct qt_example_shell_surface *qt_example_shell_surface)
{
	return wl_proxy_get_version((struct wl_proxy *) qt_example_shell_surface);
}

/**
 * @ingroup iface_qt_example_shell_surface
 */
static inline void
qt_example_shell_surface_destroy(struct qt_example_shell_surface *qt_example_shell_surface)
{
	wl_proxy_marshal_flags((struct wl_proxy *) qt_example_shell_surface,
			 QT_EXAMPLE_SHELL_SURFACE_DESTROY, NULL, wl_proxy_get_version((struct wl_proxy *) qt_example_shell_surface), WL_MARSHAL_FLAG_DESTROY);
}

/**
 * @ingroup iface_qt_example_shell_surface
 */
static inline void
qt_example_shell_surface_set_window_title(struct qt_example_shell_surface *qt_example_shell_surface, const char *window_title)
{
	wl_proxy_marshal_flags((struct wl_proxy *) qt_example_shell_surface,
			 QT_EXAMPLE_SHELL_SURFACE_SET_WINDOW_TITLE, NULL, wl_proxy_get_version((struct wl_proxy *) qt_example_shell_surface), 0, window_title);
}

/**
 * @ingroup iface_qt_example_shell_surface
 */
static inline void
qt_example_shell_surface_set_minimized(struct qt_example_shell_surface *qt_example_shell_surface, uint32_t minimized)
{
	wl_proxy_marshal_flags((struct wl_proxy *) qt_example_shell_surface,
			 QT_EXAMPLE_SHELL_SURFACE_SET_MINIMIZED, NULL, wl_proxy_get_version((struct wl_proxy *) qt_example_shell_surface), 0, minimized);
}

#ifndef QT_EXAMPLE_SHELL_ERROR_ENUM
#define QT_EXAMPLE_SHELL_ERROR_ENUM
enum qt_example_shell_error {
	/**
	 * wl_surface already has a different role
	 */
	QT_EXAMPLE_SHELL_ERROR_ROLE = 0,
};
#endif /* QT_EXAMPLE_SHELL_ERROR_ENUM */

#define QT_EXAMPLE_SHELL_SURFACE_CREATE 0


/**
 * @ingroup iface_qt_example_shell
 */
#define QT_EXAMPLE_SHELL_SURFACE_CREATE_SINCE_VERSION 1

/** @ingroup iface_qt_example_shell */
static inline void
qt_example_shell_set_user_data(struct qt_example_shell *qt_example_shell, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) qt_example_shell, user_data);
}

/** @ingroup iface_qt_example_shell */
static inline void *
qt_example_shell_get_user_data(struct qt_example_shell *qt_example_shell)
{
	return wl_proxy_get_user_data((struct wl_proxy *) qt_example_shell);
}

static inline uint32_t
qt_example_shell_get_version(struct qt_example_shell *qt_example_shell)
{
	return wl_proxy_get_version((struct wl_proxy *) qt_example_shell);
}

/** @ingroup iface_qt_example_shell */
static inline void
qt_example_shell_destroy(struct qt_example_shell *qt_example_shell)
{
	wl_proxy_destroy((struct wl_proxy *) qt_example_shell);
}

/**
 * @ingroup iface_qt_example_shell
 */
static inline struct qt_example_shell_surface *
qt_example_shell_surface_create(struct qt_example_shell *qt_example_shell, struct wl_surface *surface)
{
	struct wl_proxy *id;

	id = wl_proxy_marshal_flags((struct wl_proxy *) qt_example_shell,
			 QT_EXAMPLE_SHELL_SURFACE_CREATE, &qt_example_shell_surface_interface, wl_proxy_get_version((struct wl_proxy *) qt_example_shell), 0, surface, NULL);

	return (struct qt_example_shell_surface *) id;
}

#ifdef  __cplusplus
}
#endif

#endif
