/* Generated by wayland-scanner 1.21.0 */

#ifndef EXAMPLE_SHELL_SERVER_PROTOCOL_H
#define EXAMPLE_SHELL_SERVER_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-server-core.h"

#ifdef  __cplusplus
extern "C" {
#endif

struct wl_client;
struct wl_resource;

/**
 * @page page_example_shell The example_shell protocol
 * @section page_ifaces_example_shell Interfaces
 * - @subpage page_iface_qt_example_shell_surface - 
 * - @subpage page_iface_qt_example_shell - 
 * @section page_copyright_example_shell Copyright
 * <pre>
 *
 * Copyright (C) 2021 The Qt Company Ltd.
 * SPDX-License-Identifier: LicenseRef-Qt-Commercial OR BSD-3-Clause
 * </pre>
 */
struct qt_example_shell;
struct qt_example_shell_surface;
struct wl_surface;

#ifndef QT_EXAMPLE_SHELL_SURFACE_INTERFACE
#define QT_EXAMPLE_SHELL_SURFACE_INTERFACE
/**
 * @page page_iface_qt_example_shell_surface qt_example_shell_surface
 * @section page_iface_qt_example_shell_surface_api API
 * See @ref iface_qt_example_shell_surface.
 */
/**
 * @defgroup iface_qt_example_shell_surface The qt_example_shell_surface interface
 */
extern const struct wl_interface qt_example_shell_surface_interface;
#endif
#ifndef QT_EXAMPLE_SHELL_INTERFACE
#define QT_EXAMPLE_SHELL_INTERFACE
/**
 * @page page_iface_qt_example_shell qt_example_shell
 * @section page_iface_qt_example_shell_api API
 * See @ref iface_qt_example_shell.
 */
/**
 * @defgroup iface_qt_example_shell The qt_example_shell interface
 */
extern const struct wl_interface qt_example_shell_interface;
#endif

/**
 * @ingroup iface_qt_example_shell_surface
 * @struct qt_example_shell_surface_interface
 */
struct qt_example_shell_surface_interface {
	/**
	 */
	void (*destroy)(struct wl_client *client,
			struct wl_resource *resource);
	/**
	 */
	void (*set_window_title)(struct wl_client *client,
				 struct wl_resource *resource,
				 const char *window_title);
	/**
	 */
	void (*set_minimized)(struct wl_client *client,
			      struct wl_resource *resource,
			      uint32_t minimized);
};

#define QT_EXAMPLE_SHELL_SURFACE_MINIMIZE 0

/**
 * @ingroup iface_qt_example_shell_surface
 */
#define QT_EXAMPLE_SHELL_SURFACE_MINIMIZE_SINCE_VERSION 1

/**
 * @ingroup iface_qt_example_shell_surface
 */
#define QT_EXAMPLE_SHELL_SURFACE_DESTROY_SINCE_VERSION 1
/**
 * @ingroup iface_qt_example_shell_surface
 */
#define QT_EXAMPLE_SHELL_SURFACE_SET_WINDOW_TITLE_SINCE_VERSION 1
/**
 * @ingroup iface_qt_example_shell_surface
 */
#define QT_EXAMPLE_SHELL_SURFACE_SET_MINIMIZED_SINCE_VERSION 1

/**
 * @ingroup iface_qt_example_shell_surface
 * Sends an minimize event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
qt_example_shell_surface_send_minimize(struct wl_resource *resource_, uint32_t minimized)
{
	wl_resource_post_event(resource_, QT_EXAMPLE_SHELL_SURFACE_MINIMIZE, minimized);
}

#ifndef QT_EXAMPLE_SHELL_ERROR_ENUM
#define QT_EXAMPLE_SHELL_ERROR_ENUM
enum qt_example_shell_error {
	/**
	 * wl_surface already has a different role
	 */
	QT_EXAMPLE_SHELL_ERROR_ROLE = 0,
};
#endif /* QT_EXAMPLE_SHELL_ERROR_ENUM */

/**
 * @ingroup iface_qt_example_shell
 * @struct qt_example_shell_interface
 */
struct qt_example_shell_interface {
	/**
	 */
	void (*surface_create)(struct wl_client *client,
			       struct wl_resource *resource,
			       struct wl_resource *surface,
			       uint32_t id);
};


/**
 * @ingroup iface_qt_example_shell
 */
#define QT_EXAMPLE_SHELL_SURFACE_CREATE_SINCE_VERSION 1

#ifdef  __cplusplus
}
#endif

#endif
