/* Generated by wayland-scanner 1.21.0 */

#ifndef SHARE_BUFFER_CLIENT_PROTOCOL_H
#define SHARE_BUFFER_CLIENT_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-client-core.h"

#ifdef  __cplusplus
extern "C" {
#endif

/**
 * @page page_share_buffer The share_buffer protocol
 * @section page_ifaces_share_buffer Interfaces
 * - @subpage page_iface_qt_share_buffer - 
 * @section page_copyright_share_buffer Copyright
 * <pre>
 *
 * Copyright (C) 2015 The Qt Company Ltd.
 * SPDX-License-Identifier: LicenseRef-Qt-Commercial OR BSD-3-Clause
 * </pre>
 */
struct qt_server_buffer;
struct qt_share_buffer;

#ifndef QT_SHARE_BUFFER_INTERFACE
#define QT_SHARE_BUFFER_INTERFACE
/**
 * @page page_iface_qt_share_buffer qt_share_buffer
 * @section page_iface_qt_share_buffer_api API
 * See @ref iface_qt_share_buffer.
 */
/**
 * @defgroup iface_qt_share_buffer The qt_share_buffer interface
 */
extern const struct wl_interface qt_share_buffer_interface;
#endif

/**
 * @ingroup iface_qt_share_buffer
 * @struct qt_share_buffer_listener
 */
struct qt_share_buffer_listener {
	/**
	 */
	void (*cross_buffer)(void *data,
			     struct qt_share_buffer *qt_share_buffer,
			     struct qt_server_buffer *buffer);
};

/**
 * @ingroup iface_qt_share_buffer
 */
static inline int
qt_share_buffer_add_listener(struct qt_share_buffer *qt_share_buffer,
			     const struct qt_share_buffer_listener *listener, void *data)
{
	return wl_proxy_add_listener((struct wl_proxy *) qt_share_buffer,
				     (void (**)(void)) listener, data);
}

/**
 * @ingroup iface_qt_share_buffer
 */
#define QT_SHARE_BUFFER_CROSS_BUFFER_SINCE_VERSION 1


/** @ingroup iface_qt_share_buffer */
static inline void
qt_share_buffer_set_user_data(struct qt_share_buffer *qt_share_buffer, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) qt_share_buffer, user_data);
}

/** @ingroup iface_qt_share_buffer */
static inline void *
qt_share_buffer_get_user_data(struct qt_share_buffer *qt_share_buffer)
{
	return wl_proxy_get_user_data((struct wl_proxy *) qt_share_buffer);
}

static inline uint32_t
qt_share_buffer_get_version(struct qt_share_buffer *qt_share_buffer)
{
	return wl_proxy_get_version((struct wl_proxy *) qt_share_buffer);
}

/** @ingroup iface_qt_share_buffer */
static inline void
qt_share_buffer_destroy(struct qt_share_buffer *qt_share_buffer)
{
	wl_proxy_destroy((struct wl_proxy *) qt_share_buffer);
}

#ifdef  __cplusplus
}
#endif

#endif
