/* Generated by wayland-scanner 1.21.0 */

#ifndef DRM_EGL_SERVER_BUFFER_CLIENT_PROTOCOL_H
#define DRM_EGL_SERVER_BUFFER_CLIENT_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-client-core.h"

#ifdef  __cplusplus
extern "C" {
#endif

/**
 * @page page_drm_egl_server_buffer The drm_egl_server_buffer protocol
 * @section page_ifaces_drm_egl_server_buffer Interfaces
 * - @subpage page_iface_qt_drm_egl_server_buffer - 
 * @section page_copyright_drm_egl_server_buffer Copyright
 * <pre>
 *
 * Copyright (C) 2015 The Qt Company Ltd.
 * SPDX-License-Identifier: LicenseRef-Qt-Commercial OR BSD-3-Clause
 * </pre>
 */
struct qt_drm_egl_server_buffer;
struct qt_server_buffer;

#ifndef QT_DRM_EGL_SERVER_BUFFER_INTERFACE
#define QT_DRM_EGL_SERVER_BUFFER_INTERFACE
/**
 * @page page_iface_qt_drm_egl_server_buffer qt_drm_egl_server_buffer
 * @section page_iface_qt_drm_egl_server_buffer_api API
 * See @ref iface_qt_drm_egl_server_buffer.
 */
/**
 * @defgroup iface_qt_drm_egl_server_buffer The qt_drm_egl_server_buffer interface
 */
extern const struct wl_interface qt_drm_egl_server_buffer_interface;
#endif

#ifndef QT_DRM_EGL_SERVER_BUFFER_FORMAT_ENUM
#define QT_DRM_EGL_SERVER_BUFFER_FORMAT_ENUM
enum qt_drm_egl_server_buffer_format {
	QT_DRM_EGL_SERVER_BUFFER_FORMAT_RGBA32 = 0,
	QT_DRM_EGL_SERVER_BUFFER_FORMAT_A8 = 1,
};
#endif /* QT_DRM_EGL_SERVER_BUFFER_FORMAT_ENUM */

/**
 * @ingroup iface_qt_drm_egl_server_buffer
 * @struct qt_drm_egl_server_buffer_listener
 */
struct qt_drm_egl_server_buffer_listener {
	/**
	 */
	void (*server_buffer_created)(void *data,
				      struct qt_drm_egl_server_buffer *qt_drm_egl_server_buffer,
				      struct qt_server_buffer *id,
				      int32_t name,
				      int32_t width,
				      int32_t height,
				      int32_t stride,
				      int32_t format);
};

/**
 * @ingroup iface_qt_drm_egl_server_buffer
 */
static inline int
qt_drm_egl_server_buffer_add_listener(struct qt_drm_egl_server_buffer *qt_drm_egl_server_buffer,
				      const struct qt_drm_egl_server_buffer_listener *listener, void *data)
{
	return wl_proxy_add_listener((struct wl_proxy *) qt_drm_egl_server_buffer,
				     (void (**)(void)) listener, data);
}

/**
 * @ingroup iface_qt_drm_egl_server_buffer
 */
#define QT_DRM_EGL_SERVER_BUFFER_SERVER_BUFFER_CREATED_SINCE_VERSION 1


/** @ingroup iface_qt_drm_egl_server_buffer */
static inline void
qt_drm_egl_server_buffer_set_user_data(struct qt_drm_egl_server_buffer *qt_drm_egl_server_buffer, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) qt_drm_egl_server_buffer, user_data);
}

/** @ingroup iface_qt_drm_egl_server_buffer */
static inline void *
qt_drm_egl_server_buffer_get_user_data(struct qt_drm_egl_server_buffer *qt_drm_egl_server_buffer)
{
	return wl_proxy_get_user_data((struct wl_proxy *) qt_drm_egl_server_buffer);
}

static inline uint32_t
qt_drm_egl_server_buffer_get_version(struct qt_drm_egl_server_buffer *qt_drm_egl_server_buffer)
{
	return wl_proxy_get_version((struct wl_proxy *) qt_drm_egl_server_buffer);
}

/** @ingroup iface_qt_drm_egl_server_buffer */
static inline void
qt_drm_egl_server_buffer_destroy(struct qt_drm_egl_server_buffer *qt_drm_egl_server_buffer)
{
	wl_proxy_destroy((struct wl_proxy *) qt_drm_egl_server_buffer);
}

#ifdef  __cplusplus
}
#endif

#endif
